commit db89119d40390b8db0ea65278a6020e9653651ff
Author: Kirill A. Shutemov <kirill@shutemov.name>
Date:   Wed Jan 20 00:56:15 2010 +0100

    block/qcow2.c: fix warnings with _FORTIFY_SOURCE
    
    CC    block/qcow2.o
    cc1: warnings being treated as errors
    block/qcow2.c: In function 'qcow_create2':
    block/qcow2.c:829: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:838: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:839: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:841: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:844: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:849: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:852: error: ignoring return value of 'write', declared with attribute warn_unused_result
    block/qcow2.c:855: error: ignoring return value of 'write', declared with attribute warn_unused_result
    make: *** [block/qcow2.o] Error 1
    
    Signed-off-by: Kirill A. Shutemov <kirill@shutemov.name>
    Signed-off-by: Juan Quintela <quintela@redhat.com>
    Signed-off-by: Anthony Liguori <aliguori@us.ibm.com>

Index: qemu-kvm-0.12.3/block/qcow2.c
===================================================================
--- qemu-kvm-0.12.3.orig/block/qcow2.c
+++ qemu-kvm-0.12.3/block/qcow2.c
@@ -754,7 +754,7 @@ static int qcow_create2(const char *file
     uint64_t old_ref_clusters;
     QCowCreateState s1, *s = &s1;
     QCowExtension ext_bf = {0, 0};
-
+    int ret;
 
     memset(s, 0, sizeof(*s));
 
@@ -858,7 +858,11 @@ static int qcow_create2(const char *file
         ref_clusters * s->cluster_size);
 
     /* write all the data */
-    write(fd, &header, sizeof(header));
+    ret = qemu_write_full(fd, &header, sizeof(header));
+    if (ret != sizeof(header)) {
+        ret = -1;
+        goto exit;
+    }
     if (backing_file) {
         if (backing_format_len) {
             char zero[16];
@@ -867,25 +871,59 @@ static int qcow_create2(const char *file
             memset(zero, 0, sizeof(zero));
             cpu_to_be32s(&ext_bf.magic);
             cpu_to_be32s(&ext_bf.len);
-            write(fd, &ext_bf, sizeof(ext_bf));
-            write(fd, backing_format, backing_format_len);
-            if (padding > 0) {
-                write(fd, zero, padding);
+            ret = qemu_write_full(fd, &ext_bf, sizeof(ext_bf));
+            if (ret != sizeof(ext_bf)) {
+                ret = -1;
+                goto exit;
+            }
+            ret = qemu_write_full(fd, backing_format, backing_format_len);
+            if (ret != backing_format_len) {
+                ret = -1;
+                goto exit;
             }
+             if (padding > 0) {
+                ret = qemu_write_full(fd, zero, padding);
+                if (ret != padding) {
+                    ret = -1;
+                    goto exit;
+                }
+            }
+        }
+        ret = qemu_write_full(fd, backing_file, backing_filename_len);
+        if (ret != backing_filename_len) {
+            ret = -1;
+            goto exit;
         }
-        write(fd, backing_file, backing_filename_len);
+
     }
     lseek(fd, s->l1_table_offset, SEEK_SET);
     tmp = 0;
     for(i = 0;i < l1_size; i++) {
-        write(fd, &tmp, sizeof(tmp));
+        ret = qemu_write_full(fd, &tmp, sizeof(tmp));
+        if (ret != sizeof(tmp)) {
+            ret = -1;
+            goto exit;
+        }
     }
     lseek(fd, s->refcount_table_offset, SEEK_SET);
-    write(fd, s->refcount_table,
+    ret = qemu_write_full(fd, s->refcount_table,
         reftable_clusters * s->cluster_size);
+    if (ret != reftable_clusters * s->cluster_size) {
+        ret = -1;
+        goto exit;
+    }
+
 
     lseek(fd, s->refcount_block_offset, SEEK_SET);
-    write(fd, s->refcount_block, ref_clusters * s->cluster_size);
+    ret = qemu_write_full(fd, s->refcount_block,
+                   ref_clusters * s->cluster_size);
+    if (ret != ref_clusters * s->cluster_size) {
+        ret = -1;
+        goto exit;
+    }
+
+    ret = 0;
+exit:
 
     qemu_free(s->refcount_table);
     qemu_free(s->refcount_block);
@@ -900,7 +938,7 @@ static int qcow_create2(const char *file
         bdrv_close(bs);
     }
 
-    return 0;
+    return ret;
 }
 
 static int qcow_create(const char *filename, QEMUOptionParameter *options)
